

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedList;

import org.json.*;

public class CanchaTenis {
	public static String insertarPunto(Connection conn,String latitud,String longitud,String nombre) {
		//Primero realizamos la consulta
		PreparedStatement stmt = null;
		latitud = latitud.toLowerCase();
		longitud = longitud.toLowerCase();
		nombre = nombre.toLowerCase();
		try {
			//Cargamos los valores
			String valores =  "'"+latitud+"','"+longitud+"','"+nombre+"'";
			String instruccion = "INSERT INTO puntosgeograficos (latitud,longitud,nombre) VALUES ("+valores+")";
			stmt = conn.prepareStatement(instruccion);
			stmt.executeUpdate();
			//Obtenemos la ID
			String respuesta = CanchaTenis.consulta(conn, latitud, longitud, nombre);
			//Cerramos el ejecutador de la instruccion 
			if(stmt!=null) {
				stmt.close();
			}
			return respuesta;
		}catch (SQLException e){
			if(stmt!=null) {
				try {
					stmt.close();
				} catch (SQLException e1) {
					//Retorna el resultado erroneo
					return e1.getMessage();
				}
			}
			//Retorna el resultado erroneo
			return e.getMessage();
		}
	}
	
	public static String eliminar(Connection conn,String id) {
		PreparedStatement stmt = null;
		try {
			stmt = conn.prepareStatement("DELETE FROM puntosgeograficos where id = "+id);
			boolean resultado = 0 < stmt.executeUpdate();
			//Cerramos las conexiones
			if(stmt!=null) {
				stmt.close();
			}
			//retornamos el resultado
			return ""+resultado;
		}catch (SQLException e){
			if(stmt!=null) {
				try {
					stmt.close();
				} catch (SQLException e1) {
					return e1.getMessage();
				}
			}
			return e.getMessage();
		}
	}
	
	public static String consulta(Connection conn,String latitud,String longitud,String nombre) {
		PreparedStatement stmt = null;
		ResultSet resultado = null;
		latitud = "'"+latitud+"'";
		longitud = "'"+longitud+"'";
		nombre = "'"+nombre+"'";
		//Preparamos el cargador de datos
		String entregar = "";
		try {
			stmt = conn.prepareStatement("SELECT * FROM puntosgeograficos where latitud = "+latitud+ " and longitud = "+longitud+" and nombre = "+nombre);
			resultado = stmt.executeQuery();
			while(resultado.next()) {
				entregar = resultado.getString("id");
			}
			//Cerramos las conexiones
			if(resultado!=null) {
				resultado.close();
			}
			if(stmt!=null) {
				stmt.close();
			}
			//retornamos el resultado
			return entregar;
		}catch (SQLException e){
			if(resultado!=null) {
				try {
					resultado.close();
				} catch (SQLException e1) {
					entregar = e1.getMessage();
					return entregar;
				}
			}
			if(stmt!=null) {
				try {
					stmt.close();
				} catch (SQLException e1) {
					entregar = e1.getMessage();
					return entregar;
				}
			}
			entregar = e.getMessage();
			return entregar;
		}
	}
	
	public static JSONObject puntosCercanos(Connection conn,String latitud,String longitud) {
		//Creamos el JSON
		JSONObject objetoJSON = new JSONObject();
		//Cargamos los dato de la consulta en un array de string
		LinkedList<String[]> resultados = CanchaTenis.obtenerFilas(conn);
		//Ahora vamos a hallar las distancias y cargamos la informacion en un archivo JSON
		double radioTierra = 6371;
		for(String[] indice:resultados) {
			double dLatitud = Math.toRadians(Double.parseDouble(latitud)-Double.parseDouble(indice[1]));
			double dLongitud = Math.toRadians(Double.parseDouble(longitud)-Double.parseDouble(indice[2]));
			double parte1 = Math.sin(dLatitud/2) * Math.sin(dLatitud/2) + Math.cos(Math.toRadians(Double.parseDouble(latitud))) 
					* Math.cos(Math.toRadians(Double.parseDouble(indice[1]))) * Math.sin(dLongitud/2) * Math.sin(dLongitud/2); 
			double parte2 = 2 * Math.atan2(Math.sqrt(parte1), Math.sqrt(1-parte1));
			double distancia = radioTierra * parte2;
			JSONObject fila = new JSONObject();
			fila.put("latitud", indice[1]);
			fila.put("longitud", indice[2]);
			fila.put("distancia", distancia);
			fila.put("nombre", indice[3]);
			objetoJSON.put(String.valueOf(indice[0]), fila);
		}
		return objetoJSON;
	}
	
	public static LinkedList<String[]> obtenerFilas(Connection conn){
		PreparedStatement stmt = null;
		ResultSet resultado = null;
		//Preparamos el cargador de datos
		LinkedList<String[]> entregar = new LinkedList<>();
		try {
			stmt = conn.prepareStatement("SELECT * FROM puntosgeograficos");
			resultado = stmt.executeQuery();
			while(resultado.next()) {
				String[] resultados = new String[4];
				resultados[0] = resultado.getString("id");
				resultados[1] = resultado.getString("latitud");
				resultados[2] = resultado.getString("longitud");
				resultados[3] = resultado.getString("nombre");
				entregar.add(resultados);
			}
			//Cerramos las conexiones
			if(resultado!=null) {
				resultado.close();
			}
			if(stmt!=null) {
				stmt.close();
			}
			//retornamos el resultado
			return entregar;
		}catch (SQLException e){
			if(resultado!=null) {
				try {
					resultado.close();
				} catch (SQLException e1) {
					System.out.println(e1.getMessage());
					return null;
				}
			}
			if(stmt!=null) {
				try {
					stmt.close();
				} catch (SQLException e1) {
					System.out.println(e1.getMessage());
					return null;
				}
			}
			System.out.println(e.getMessage());
			return null;
		}
	}
	
	public static JSONObject buscarPunto(Connection conn,String id) {
		PreparedStatement stmt = null;
		ResultSet resultado = null;
		//Preparamos el cargador de datos
		JSONObject salida = new JSONObject();
		try {
			stmt = conn.prepareStatement("SELECT * FROM puntosgeograficos where id = "+id);
			resultado = stmt.executeQuery();
			while(resultado.next()) {
				salida.put("latitud",resultado.getString("latitud"));
				salida.put("longitud",resultado.getString("longitud"));
				salida.put("nombre", resultado.getString("nombre"));
			}
			//Cerramos las conexiones
			if(resultado!=null) {
				resultado.close();
			}
			if(stmt!=null) {
				stmt.close();
			}
			//retornamos el resultado
			return salida;
		}catch (SQLException e){
			if(resultado!=null) {
				try {
					resultado.close();
				} catch (SQLException e1) {
					return null;
				}
			}
			if(stmt!=null) {
				try {
					stmt.close();
				} catch (SQLException e1) {
					return null;
				}
			}
			return null;
		}
	}
}
