

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONObject;

/**
 * Servlet implementation class punto
 */
@WebServlet({"/punto/*","/guardar","/buscar_puntos"})
public class resultado extends HttpServlet {
	@Override
	protected void doDelete(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		//Comprobar el api key
		String apiKey = req.getHeader("x-api-key");
		if(apiKey == null || apiKey.compareTo("12345678")!=0) {
			resp.sendError(403,"No tiene los privilegios suficientes");
		}
		String url = req.getRequestURL().toString();
		String [] partes = url.split("/");
		if("punto".compareTo(partes[partes.length-2])==0) {
			String id = partes[partes.length-1];
			//Realizamos la conexion
			Connection conn = null;
			String direccion = "jdbc:postgresql://192.168.67.159:5432/Geo";
			try {
				conn = DriverManager.getConnection(direccion, "postgres", "postgres");
				//Insertamos el dato
				String resultado = CanchaTenis.eliminar(conn, id);
				//Cerramos la conexion
				if(!conn.isClosed()) {
					conn.close();
				}
				//Retornamos el resultado
				PrintWriter salida = resp.getWriter();
				salida.append(resultado.toString());
			}catch(SQLException e) {
				//Retornamos el resultado erroneo
				try {
					//Cerramos la conexion con la base de datos y retornamos el resultado
					if(!conn.isClosed()) {
						conn.close();
					}
				}catch (SQLException e1) {
					PrintWriter salida = resp.getWriter();
					salida.append(e1.getMessage());
				}
				PrintWriter salida = resp.getWriter();
				salida.append(e.getMessage());
			}
		}
	}

	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public resultado() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		//Comprobar el api key
		String apiKey = request.getHeader("x-api-key");
		if(apiKey == null || apiKey.compareTo("12345678")!=0) {
			response.sendError(403,"No tiene los privilegios suficientes");
		}
		String url = request.getRequestURL().toString();
		String [] partes = url.split("/");
		if("punto".compareTo(partes[partes.length-2])==0) {
			response.setContentType("application/json");
			//Obtenemos el id a la cual vamos a consultar
			String id = partes[partes.length-1];
			//Realizamos la conexion con la base de datos
			JSONObject resultado;
			Connection conn = null;
			String direccion = "jdbc:postgresql://192.168.67.159:5432/Geo";
			try {
				conn = DriverManager.getConnection(direccion, "postgres", "postgres");
				//Insertamos el dato
				resultado = CanchaTenis.buscarPunto(conn, id);
				//Cerramos la conexion
				if(!conn.isClosed()) {
					conn.close();
				}
				//Retornamos el resultado
				if(resultado.isEmpty()) {
					response.sendError(404,"No existe el registro en la base de datos");
				}
				//Retornamos el resultado
				PrintWriter salida = response.getWriter();
				salida.append(resultado.toString());
			}catch(SQLException e) {
				//Retornamos el resultado erroneo
				try {
					//Cerramos la conexion con la base de datos y retornamos el resultado
					if(!conn.isClosed()) {
						conn.close();
					}
				}catch (SQLException e1) {
					PrintWriter salida = response.getWriter();
					salida.append(e1.getMessage());
				}
				PrintWriter salida = response.getWriter();
				salida.append(e.getMessage());
			}
		}else if("buscar_puntos".compareTo(partes[partes.length-1])==0) {
			response.setContentType("application/json");
			//Obtenemos el id a la cual vamos a consultar
			String id = partes[partes.length-1];
			//Realizamos la conexion con la base de datos
			JSONObject resultado;
			Connection conn = null;
			String direccion = "jdbc:postgresql://192.168.67.159:5432/Geo";
			String latitud = request.getParameter("latitud");
			String longitud = request.getParameter("longitud");
			try {
				conn = DriverManager.getConnection(direccion, "postgres", "postgres");
				//Insertamos el dato
				resultado = CanchaTenis.puntosCercanos(conn, latitud, longitud);
				//Cerramos la conexion
				if(!conn.isClosed()) {
					conn.close();
				}
				PrintWriter salida = response.getWriter();
				salida.append(resultado.toString());
			}catch(SQLException e) {
				//Retornamos el resultado erroneo
				try {
					//Cerramos la conexion con la base de datos y retornamos el resultado
					if(!conn.isClosed()) {
						conn.close();
					}
				}catch (SQLException e1) {
					PrintWriter salida = response.getWriter();
					salida.append(e1.getMessage());
				}
				PrintWriter salida = response.getWriter();
				salida.append(e.getMessage());
			}
		}
//		String salida = "";
//		for(int i = 0;i<partes.length;i++) {
//			salida = salida+partes[i]+"\n";
//		}
//		PrintWriter resultado = response.getWriter();
//		resultado.append(salida);
		
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		//Comprobar el api key
		String apiKey = request.getHeader("x-api-key");
		if(apiKey == null || apiKey.compareTo("12345678")!=0) {
			response.sendError(403,"No tiene los privilegios suficientes");
		}
		String url = request.getRequestURL().toString();
		String [] partes = url.split("/");
		//Comprobamos si la peticion es para guardar una informacion
		if("guardar".compareTo(partes[partes.length-1])==0) {
			String latitud = request.getParameter("latitud");
			String longitud = request.getParameter("longitud");
			String nombre = request.getParameter("nombre");
			//Realizamos la conexion
			Connection conn = null;
			String direccion = "jdbc:postgresql://192.168.67.159:5432/Geo";
			try {
				conn = DriverManager.getConnection(direccion, "postgres", "postgres");
				//Insertamos el dato
				String resultado = CanchaTenis.insertarPunto(conn, latitud, longitud, nombre);
				//Cerramos la conexion
				if(!conn.isClosed()) {
					conn.close();
				}
				//Retornamos el resultado
				PrintWriter salida = response.getWriter();
				salida.append(resultado);
			}catch(SQLException e) {
				//Retornamos el resultado erroneo
				try {
					//Cerramos la conexion con la base de datos y retornamos el resultado
					if(!conn.isClosed()) {
						conn.close();
					}
				}catch (SQLException e1) {
					PrintWriter salida = response.getWriter();
					salida.append(e1.getMessage());
				}
				PrintWriter salida = response.getWriter();
				salida.append(e.getMessage());
			}
		}
	}

}
